% Reazione dallo stato
M=10;
m=1;
l=2;
g=9.8;


d1=0.3;
d2=0.2;


A=[0    0                      1               0 
     0    0                      0               1 
     0  -m*g/M              -d1/M         d2/(M*l)
     0   g*(M+m)/(M*l)    d1/(M*l)   -d2*(M+m)/(l*l*m*M)  ];


B=[0; 0; 1/M; -1/(M*l)];

C=[1 0 0 0];


Reg=[A B; C 0];
if det(Reg)==0
    disp('Problema del regolatore non risolvibile')
    return
end


A=A*1.0;
B=B*1.0;


R=[B A*B A*A*B A*A*A*B];
if det(R)==0
    disp('Sistema non completamente controllabile')
    return
end


% Assegnazione delle dinamiche dello stato
%R_1=inv(R)
%g1=R_1(4,:)
%K1=-g1*(A+eye(4))^4
K1=acker(A,-B,[-1 -1 -1 -1]);
eig(A+B*K1)



O=[C; C*A; C*A^2; C*A^3]
if det(O)==0
    disp('Sistema non osservabile')
    return
end


%O_1=inv(O)
%g2=O_1(:,4)
%K2=((A+2*eye(4))^4)*g2

K2=acker(A',C',[-1 -1 -1 -1]*4)'
eig(A-K2*C)


% Matrici dell'osservatore
Aoss=(A-K2*C);
Boss=[B K2];
Coss=eye(4);
Doss=zeros(4,2);





%Controllore digitale dallo stato
Tc=0.1;
bit=10;
Qy=32/(2^bit);
Qt=1.5/(2^bit);
Qyp=10/(2^bit);
Qtp=1.5/(2^bit);
Qu=60/(2^bit);


% Fnzione di trasferimento
num=[0.3 0.2 -2.94];den=[0.3 +0.35 -3.762 -0.882 0];
F=tf(num,den)
%figure(1),bode(F)
%figure(2),nyquist(F)